<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php');

///////////////////////////////////////////////
// Validation de la requête : rep ou matière //
///////////////////////////////////////////////

// Récupération de l'identifiant de répertoire demandé
$mysqli = premiere_connexion();
if ( isset($_REQUEST['rep']) && is_numeric($rid = $_REQUEST['rep']) )  {
  $resultat = $mysqli->query("SELECT id FROM reps WHERE id = $rid");
  if ( $resultat->num_rows )
    $resultat->free();
  else
    $rid = 1;
}
else  {
  // Si une matière est demandée
  if ( !empty($_REQUEST) )  {
    $resultat = $mysqli->query('SELECT r.id, m.cle FROM reps AS r LEFT JOIN matieres AS m ON r.matiere = m.id');
    if ( $resultat->num_rows )  {
      while ( $r = $resultat->fetch_assoc() )
      if ( isset($_REQUEST[$r['cle']]) )  {
        $rid = $r['id'];
        break;
      }
      $resultat->free();
    }
  }
  // Valeur par défaut
  if ( !isset($rid) )
    $rid = 1;
}

//////////////////////////////////
// Modifications de répertoires //
//////////////////////////////////
if ( ( $admin ) && ( isset($_REQUEST['modifie']) || isset($_REQUEST['supprime']) || isset($_REQUEST['cree']) ) )  {
  // Connexion à la base de données
  $mysqli->close();
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Récupération des données du répertoire
  $resultat = $mysqli->query("SELECT nom, parent, protection, nbrep+nbdoc_v+nbdoc_nv AS nb FROM reps WHERE id = $rid");
  $rep = $resultat->fetch_assoc();
  $resultat->free();

  // Récupération des liens de parenté entre répertoires
  $resultat = $mysqli->query("SELECT id, parents FROM reps");
  while ( $r = $resultat->fetch_assoc() )
    $parents[$r['id']] = $r['parents'];
  $resultat->free();

  // Sauvegarde des tables contenant les données -- une fois pour toutes
  sauvegarde_mysql('reps');
  sauvegarde_mysql('docs');

  // Traitement d'une modification du répertoire actuel
  // Une partie est impossible si $rep['parent'] est nul (répertoires racines de matières)
  if ( isset($_REQUEST['modifie']) )  {
    $message = '';

    // Modification du nom
    if ( isset($_REQUEST['nom']) && ( $rep['parent'] ) && ( strlen($nom = $_REQUEST['nom']) ) && ( $rep['nom'] != $nom ) )  {
      $nom = $mysqli->real_escape_string($_REQUEST['nom']);
      $message = ( $mysqli->query("UPDATE reps SET nom = '$nom' WHERE id = $rid")
                && $mysqli->query('ALTER TABLE reps ORDER BY parents,nom')
      ) ? 'Le nom du répertoire <em>'.stripslashes($rep['nom'] = $nom).'</em> a bien été modifié.' : "Le nom du répertoire <em>${rep['nom']}</em> n'a pas pu être modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    }

    // Déplacement du répertoire
    if ( isset($_REQUEST['parent']) && ( $rep['parent'] ) && isset($parents[$parent=$_REQUEST['parent']]) && ( $parent != $rep['parent'] ) && ( !in_array($rid,explode(',',$parents[$parent])) ) )  {
      // Récupération de l'éventuelle nouvelle matière
      $resultat = $mysqli->query("SELECT matiere FROM reps WHERE id = $parent");
      $r = $resultat->fetch_assoc();
      $resultat->free();
      $mat = $r['matiere'];
      $parents = "${parents[$parent]},$parent";
      // Modifications
      $message .= ( $mysqli->query("UPDATE reps SET matiere = $mat, parent = $parent, parents = '$parents' WHERE id = $rid")
                 && $mysqli->query('ALTER TABLE reps ORDER BY parents,nom')
                 && $mysqli->query("UPDATE reps SET nbrep = (nbrep + 1) WHERE id = $parent")
                 && $mysqli->query("UPDATE reps SET nbrep = (nbrep - 1) WHERE id = ${rep['parent']}")
                 && $mysqli->query("UPDATE reps SET matiere = $mat, parents = '$parents,$rid' WHERE parent = $rid")
                 && $mysqli->query("UPDATE docs SET matiere = $mat, parents = '$parents,$rid' WHERE parent = $rid")
      ) ? " Le répertoire <em>${rep['nom']}</em> a bien été déplacé." : " Le répertoire <em>${rep['nom']}</em> n'a pas pu être déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    }

    // Modification de la demande d'identification pour accéder au répertoire
    $protection = isset($_REQUEST['protection']) ? 1 : 0;
    if ( $protection != $rep['protection'] )
      $message .= ( $mysqli->query("UPDATE reps SET protection = $protection WHERE id = $rid") ) ? " La visibilité du répertoire <em>${rep['nom']}</em> a bien été modifiée." : " La visibilité du répertoire <em>${rep['nom']}</em> n'a pas pu être modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    
    // Propagation de demande d'identification aux sous-répertoires et documents
    if ( isset($_REQUEST['propagation']) && ( $rep['nb'] ) )
      $message .=  ( $mysqli->query("UPDATE reps SET protection = $protection WHERE FIND_IN_SET($rid,parents)")
                  && $mysqli->query("UPDATE docs SET protection = $protection WHERE FIND_IN_SET($rid,parents) AND protection < 2")
      ) ? " La visibilité du répertoire <em>${rep['nom']}</em> a bien été propagée à tout son contenu (sous-répertoires et documents)." : " La visibilité du répertoire <em>${rep['nom']}</em> a bien été propagée à tout son contenu (sous-répertoires et documents). Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';

    if ( !strlen($message) )
      unset($message);
  }

  // Suppression du répertoire actuel
  elseif ( isset($_REQUEST['supprime']) && ( $rep['parent'] ) && ( !$rep['nb'] ) )  {
    $message = ( $mysqli->query("DELETE FROM reps WHERE id = $rid")
               && $mysqli->query("UPDATE reps SET nbrep = (nbrep - 1) WHERE id = ${rep['parent']}")
    ) ? "La suppression du répertoire <em>${rep['nom']}</em> a bien été effectuée." : "La suppression du répertoire <em>${rep['nom']}</em> n'a pas été effectuée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    $rid = $rep['parent'];
  }

  // Création d'un sous-répertoire
  elseif ( isset($_REQUEST['cree']) && ( strlen($_REQUEST['nom']) ) )  {
    $nom = $mysqli->real_escape_string($_REQUEST['nom']);
    $protection = isset($_REQUEST['protection']) ? 1 : 0;
    $message = ( $mysqli->query("INSERT INTO reps SET parent = $rid, parents = '${parents[$rid]},$rid', nom = '$nom', matiere = (SELECT r.matiere FROM reps AS r WHERE r.id = $rid), nbrep = 0, nbdoc_v = 0, nbdoc_nv = 0, protection = $protection")
              && $mysqli->query("UPDATE reps SET nbrep = (nbrep + 1) WHERE id = $rid")
              && $mysqli->query('ALTER TABLE reps ORDER BY parents,nom')
    ) ? 'Le répertoire <em>'.stripslashes($nom).'</em> a bien été créé.' : 'Le répertoire <em>'.stripslashes($nom).'</em> n\'a pas pu être créé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
  }

  // Mise à jour des champs 'docs' dans la table 'matieres' (pour le menu)
  $mysqli->query('UPDATE matieres SET docs = (SELECT IF(SUM(nbdoc_v),1,0) FROM reps WHERE matiere = matieres.id)');
  // Passage en connexion MySQL en lecture seulement
  $mysqli->close();
  $mysqli = new mysqli($serveur,$base,$mdp,$base);
  $mysqli->set_charset('utf8');
}

////////////////////////////////
// Modifications de documents //
////////////////////////////////
elseif ( ( $admin ) && isset($_REQUEST['id']) && is_numeric($id = $_REQUEST['id']) )  {
  // Connexion à la base de données
  $mysqli->close();
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Récupération des données relatives au document
  if ( $id )  {
    $resultat = $mysqli->query("SELECT nom, protection, parent, ext, lien FROM docs WHERE id = $id");
    if ( $resultat->num_rows )  {
      $doc = $resultat->fetch_assoc();
      $resultat->free();
    }
    else
      $id = 0;
  }

  // Sauvegarde des tables contenant les données -- une fois pour toutes
  sauvegarde_mysql('reps');
  sauvegarde_mysql('docs');

  // Traitement d'une modification d'un document
  if ( isset($_REQUEST['modifie_doc']) && ( $id ) )  {
    if ( !strlen($_REQUEST['nom']) )
      $message = 'Il n\'est pas possible de valider un nom de fichier vide. Pour supprimer un fichier, il faut cliquer sur Supprimer.';
    else  {
      $message = '';

      // Modification du nom
      setlocale(LC_CTYPE, "fr_FR.UTF-8");
      $nom = basename(str_replace($doc['ext'],'',$_REQUEST['nom']));
      if ( $nom != $doc['nom'] )  {
        // real_escape_string seulement pour la requête SQL
        if ( $mysqli->query('UPDATE docs SET nom = \''.$mysqli->real_escape_string($nom)."' WHERE id = $id") )  {
          exec('mv documents/'.escapeshellarg("${doc['lien']}/${doc['nom']}${doc['ext']}").' documents/'.escapeshellarg("${doc['lien']}/$nom${doc['ext']}"));
          $mysqli->query('ALTER TABLE docs ORDER BY parents,nom');
          $message = " Le nom du document <em>$nom</em> a bien été modifié.";
          $doc['nom'] = $nom;
        }
        else
          $message ="Le nom du document <em>${doc['nom']}</em> n'a pas pu être modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }

      // Modification de l'accès
      // Si $protection = 2, on enlève un document du répertoire parent ; sinon on ajoute
      $protection = ( in_array($_REQUEST['protection'],array(0,1,2)) ) ? $_REQUEST['protection'] : 0;
      if ( $protection != $doc['protection'] )  {
         $a = ($protection==2) - ($doc['protection']==2);
         $message .= ( $mysqli->query("UPDATE docs SET protection = $protection WHERE id = $id")
                   && $mysqli->query("UPDATE reps SET nbdoc_v = (nbdoc_v - ($a)), nbdoc_nv = (nbdoc_nv + ($a)) WHERE id = ${doc['parent']}") 
        ) ? " L'accès au document <em>${doc['nom']}</em> a bien été modifié." : " L'accès au document <em>${doc['nom']}</em> n'a pas pu être modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }

      // Déplacement dans un autre répertoire
      if ( is_numeric($parent = $_REQUEST['parent']) && ( $parent != $doc['parent'] ) )  {
        $resultat = $mysqli->query("SELECT parents, matiere FROM reps WHERE id = $parent");
        if ( $resultat->num_rows )  {
          $r = $resultat->fetch_assoc();
          $resultat->free();
          if ( $mysqli->query("UPDATE docs SET parent = '$parent', parents = '${r['parents']},$parent',
                               matiere = ${r['matiere']} WHERE id = $id") )  {
            $champ = ( $protection < 2 ) ? 'nbdoc_v' : 'nbdoc_nv';
            $mysqli->query("UPDATE reps SET $champ = ($champ -1) WHERE id = ${doc['parent']}");
            $mysqli->query("UPDATE reps SET $champ = ($champ + 1) WHERE id = $parent");
            $mysqli->query('ALTER TABLE docs ORDER BY parents,nom');
            $message .= " Le document <em>${doc['nom']}</em> a bien été déplacé.";
          }
          else
            $message .= " Le document <em>${doc['nom']}</em> n'a pas pu être déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
        }
      }
      
      // Si modification(s), on met à jour les informations récentes éventuelles
      if ( strlen($message) )  {
        if ( $protection < 2 )  {
          $resultat = $mysqli->query("SELECT GROUP_CONCAT( reps.nom ORDER BY FIND_IN_SET(reps.id,docs.parents) SEPARATOR '/' ) AS path
                                      FROM docs LEFT JOIN reps ON FIND_IN_SET(reps.id,docs.parents) WHERE docs.id = $id");
          $r = $resultat->fetch_assoc();
          $resultat->free();
          $path = $mysqli->real_escape_string("${r['path']}/${doc['nom']}");
          // Document auparavant non visible
          if ( $doc['protection'] == 2 )
            recent($mysqli,3,$id,$path,"download?id=$id","<p>Nouveau document&nbsp;: $path".$mysqli->real_escape_string($doc['ext']).'</p>');
          // Document auparavant visible : on met à jour les chemins, sans mettre en avant le document
          // Remarque : le RSS n'est pas modifié, le sera leur d'une nouvelle information récente
          else
            $mysqli->query("UPDATE recents SET texte = REPLACE(texte,titre,'$path'), titre = '$path' WHERE id = 3000+$id");
        }
        // Si $protection = 2, on cherche à supprimer.
        else
          recent($mysqli,3,$id);
      }
      else
        unset($message);
    }
  }
  
  // Suppression d'un document
  elseif ( isset($_REQUEST['supprime_doc']) && ( $id ) )  {
    if ( $mysqli->query("DELETE FROM docs WHERE id = $id") )  {
      $message = "Le document <em>${doc['nom']}</em> a bien été supprimé.";
      // Suppression physique
      exec("rm -rf documents/${doc['lien']}");
      // Mise à jour du répertoire
      $champ = ( $doc['protection'] < 2 ) ? 'nbdoc_v' : 'nbdoc_nv';
      $mysqli->query("UPDATE reps SET $champ = ($champ - 1) WHERE id = ${doc['parent']}");
      // Suppression de l'éventuelle information récente
      recent($mysqli,3,$id);
    }
    else
      $message = "Le document <em>${doc['nom']}</em> n'a pas pu être supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
  }

  // Mise à jour d'un document
  elseif ( isset($_REQUEST['envoie']) && ( $id ) )  {
    // Changement d'extension suspect donc interdit
    $ext = ( strpos($_FILES['fichier']['name'],'.') ) ? strrchr($_FILES['fichier']['name'],'.') : '';
    if ( $ext != $doc['ext'] )
      $message = "Le document <em>${doc['nom']}</em> n'a pas été mis à jour&nbsp;: l'extension n'est pas celle attendue.";
    else  {
      // Déplacement du document uploadé au bon endroit
      if ( move_uploaded_file($_FILES['fichier']['tmp_name'],"documents/${doc['lien']}/${doc['nom']}${doc['ext']}") )  {
        // Gestion de la taille
        $taille = intval($_FILES['fichier']['size']/1024);
        $taille = ( $taille < 1024 ) ? "$taille&nbsp;ko" : intval($taille/1024).'&nbsp;Mo';
        // Modifications dans la base de données
        $mysqli->query("UPDATE docs SET upload = DATE(NOW()), taille = '$taille'");
        // Information récente si document visible
        if ( $doc['protection'] < 2 )  {
          $resultat = $mysqli->query("SELECT GROUP_CONCAT( reps.nom ORDER BY FIND_IN_SET(reps.id,docs.parents) SEPARATOR '/' ) AS path
                                      FROM docs LEFT JOIN reps ON FIND_IN_SET(reps.id,docs.parents) WHERE docs.id = $id");
          $r = $resultat->fetch_assoc();
          $resultat->free();
          $path = $mysqli->real_escape_string("${r['path']}/${doc['nom']}");
          recent($mysqli,3,$id,$path,"download?id=$id","<p>Nouvelle version du document&nbsp;: $path".$mysqli->real_escape_string($doc['ext'])."</p>");
        }
        $message = "Le document <em>${doc['nom']}</em> a bien été mis à jour.";
      }
      else
        $message = "Le document <em>${doc['nom']}</em> n'a pas été mis à jour car le fichier envoyé n'est pas valide.";
    }
  }

  // Envoi d'un nouveau document
  elseif ( isset($_REQUEST['envoie']) )  {
    // Vérifications des données envoyées (on fait confiance aux utilisateurs connectés pour ne pas envoyer de scripts malsains)
    $nom = $_FILES['fichier']['name'];
    $ext = ( strpos($nom,'.') ) ? strrchr($nom,'.') : '';
    setlocale(LC_CTYPE, "fr_FR.UTF-8");
    $nom = basename(str_replace($ext,'', ( strlen($_REQUEST['nom']) ) ? $_REQUEST['nom'] : $nom ));
    $protection = ( in_array($_REQUEST['protection'],array(0,1,2)) ) ? $_REQUEST['protection'] : 0;
    // Création du répertoire particulier
    $lien = substr(sha1(mt_rand()),0,15);
    while ( is_dir("documents/$lien") )
      $lien = substr(sha1(mt_rand()),0,15);
    mkdir("documents/$lien");
    // Gestion de la taille
    $taille = intval($_FILES['fichier']['size']/1024);
    $taille = ( $taille < 1024 ) ? "$taille&nbsp;ko" : intval($taille/1024).'&nbsp;Mo';
    // Récupération des données du répertoire parent
    $resultat = $mysqli->query("SELECT parents, matiere FROM reps WHERE id = $rid");
    $r = $resultat->fetch_assoc();
    $resultat->free();
    // Déplacement du document uploadé au bon endroit
    if ( move_uploaded_file($_FILES['fichier']['tmp_name'],"documents/$lien/$nom$ext") )  {
      // Écriture MySQL
      if ( $mysqli->query("INSERT INTO docs SET parent = $rid, parents = '${r['parents']},$rid',
                           matiere = ${r['matiere']}, nom = '".$mysqli->real_escape_string($nom)."',
                           upload = DATE(NOW()), taille = '$taille', lien = '$lien', ext='".$mysqli->real_escape_string($ext)."', protection = $protection") )  {
        $id = $mysqli->insert_id;
        $mysqli->query('ALTER TABLE docs ORDER BY parents,nom');
        $message = "Le document <em>$nom</em> a bien été mis en ligne.";
        // Mise à jour du répertoire
        $champ = ( $protection < 2 ) ? 'nbdoc_v' : 'nbdoc_nv';
        $mysqli->query("UPDATE reps SET $champ = ($champ + 1) WHERE id = $rid");
        // Si le document est visible, ajout d'un information récente
        if ( $protection < 2 )  {
          $resultat = $mysqli->query("SELECT GROUP_CONCAT( reps.nom ORDER BY FIND_IN_SET(reps.id,docs.parents) SEPARATOR '/' ) AS path
                                      FROM docs LEFT JOIN reps ON FIND_IN_SET(reps.id,docs.parents) WHERE docs.id = $id");
          $r = $resultat->fetch_assoc();
          $resultat->free();
          $path = $mysqli->real_escape_string("${r['path']}/$nom");
          recent($mysqli,3,$id,$path,"download?id=$id","<p>Nouveau document&nbsp;: $path".$mysqli->real_escape_string($ext).'</p>');
        }
      }
      else  {
        // Retour en arrière
        exec("rm -rf documents/$lien");
        $message = "Le document <em>$nom</em> n'a pas été mis en ligne à cause d'une erreur lors des modifications dans la base de données MySQL. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }
    }
    else
      $message = "Le document <em>$nom</em> n'a pas été mis en ligne car le fichier envoyé n'est pas valide.";
  }
  
  // Mise à jour des champs 'docs' dans la table 'matieres' (pour le menu)
  $mysqli->query('UPDATE matieres SET docs = (SELECT IF(SUM(nbdoc_v),1,0) FROM reps WHERE matiere = matieres.id)');
    
  // Passage en connexion MySQL en lecture seulement
  $mysqli->close();
  $mysqli = new mysqli($serveur,$base,$mdp,$base);
  $mysqli->set_charset('utf8');
}

//////////
// HTML //
//////////

if ( $admin )  {
  // Récupération des répertoires, dans le bon ordre pour un select
  function liste($rid,$n)  {
    $resultat = $GLOBALS['mysqli']->query("SELECT id, nom, parents FROM reps WHERE parent = $rid");
    while ( $r = $resultat->fetch_assoc() )  {
      $GLOBALS['select_reps'] .= "        <option value=\"${r['id']}\">".str_repeat('&rarr;',$n)."${r['nom']}</option>\n";
      liste($r['id'],$n+1);
    }
    $resultat->free();
  }
  $select_reps = '';
  liste(0,0);
}

// Récupération des données, vérification de la protection, répertoires parents
$resultat = $mysqli->query('SELECT r.nom, r.parent, r.parents, r.nbrep + r.nbdoc_v'.( ($admin) ? ' + r.nbdoc_nv' : '' )." AS nb, r.protection, m.cle, m.nom AS mat
                            FROM reps AS r LEFT JOIN matieres AS m ON r.matiere = m.id
                            WHERE r.id = $rid");
if ( $resultat->num_rows )  {
  $rep = $resultat->fetch_assoc();
  $resultat->free();

  $p = ( is_null($rep['cle']) ) ? 'docs' : "docs?${rep['cle']}";
  if ( $admin )
    $t = "Gestion des documents - ${rep['nom']}";
  else
    $t = ( is_null($rep['cle']) ) ? 'Documents à télécharger' : "Documents à télécharger - ${rep['mat']}";

  // Demander l'identification si le répertoire est protégé et l'utilisateur non connecté
  if ( $rep['protection'] && !$lecteur && !$admin )
    include('login_lecture.php');

  // Haut de page, menu et message
  include('haut.php');

  // Répertoires parents
  $resultat = $mysqli->query("SELECT id, nom, protection FROM reps WHERE FIND_IN_SET(id,'${rep['parents']},$rid')");
  $parents = '';
  while ( $r = $resultat->fetch_assoc() )
    $parents .= "\n    <a href=\"?rep=${r['id']}\"><img class=\"icone\" src=\"icones/".( ( strlen($parents) ) ? 'next' : 'home' ).( ( $r['protection'] ) ? '-lock' : '' ).".png\">${r['nom']}</a>";
  $resultat->free();
  echo <<<FIN
  
  <div class="item" id="parents">$parents
  </div>

FIN;

  // Affichage du répertoire et de son contenu
  if ( $rep['nb'] )  {
    
    function affichage($mysqli, $rid, $n, $lecteur,$admin)  {
      $indent = str_pad('',2*$n);

      // Sous-répertoires et récursivité
      $resultat = $mysqli->query('SELECT id, nom, nbrep, nbdoc_v'.( ($admin) ? ' + nbdoc_nv' : '' )." AS nbdoc, protection FROM reps WHERE parent = $rid");
      if ( $resultat->num_rows )  {
        while ( $r = $resultat->fetch_assoc() )  {
          // Affichage du contenu si pas de protection ou utilisateur identifié
          if ( ( !$r['protection'] ) || $lecteur || $admin )  {
            if ( $r['nbrep']+$r['nbdoc'] )
              $contenu = str_replace(array('0 répertoire,',', 0 document'),'',"(${r['nbrep']} répertoire".( ( $r['nbrep'] > 1 ) ? 's' : '' ).", ${r['nbdoc']} document".( ( $r['nbdoc'] > 1 ) ? 's' : '' ).')');
            else
              $contenu = '(vide)';
            $s = ( $admin && $r['protection'] ) ? '<p class="rep open lock"><img class="icone" src="icones/rep-open-lock.png">' : '<p class="rep open"><img class="icone" src="icones/rep-open.png">';
            echo <<<FIN

$indent<div class="rep">
$indent  $s<a href="?rep=${r['id']}${GLOBALS['urladmin']}">${r['nom']}</a> $contenu</p>
FIN;
            affichage($mysqli,$r['id'],$n+1,$lecteur,$admin);
            echo "\n$indent</div>";
          }
          else
            echo <<<FIN

$indent<div class="rep">
$indent  <p class="rep lock"><img class="icone" src="icones/rep-lock.png"><a href="?rep=${r['id']}${GLOBALS['urladmin']}">${r['nom']}</a></p>
$indent</div>
FIN;
        }
        $resultat->free();
      }

      // Documents
      $resultat = $mysqli->query("SELECT id, nom, taille, DATE_FORMAT(upload,'%d/%m/%Y') AS upload, ext, protection FROM docs WHERE parent = $rid AND (protection < 2 OR ".var_export($admin,true).')');
      if ( $resultat->num_rows )  {
        while ( $r = $resultat->fetch_assoc() )  {
          switch ( $r['ext'] )  {
            case '.pdf':
              $icone = 'pdf';
              break;
            case '.doc':
            case '.odt':
            case '.docx':
              $icone = 'doc';
              break;
            case '.xls':
            case '.ods':
            case '.xlsx':
              $icone = 'xls';
              break;
            case '.ppt':
            case '.odp':
            case '.pptx':
              $icone = 'ppt';
              break;
            case '.jpg':
            case '.jpeg':
            case '.png':
            case '.gif':
            case '.svg':
            case '.tif':
            case '.tiff':
            case '.bmp':
            case '.ps':
            case '.eps':
              $icone = 'jpg';
              break;
            case '.py':
              $icone = 'python';
              break;
            case '.avi':
            case '.mpeg':
            case '.mpg':
            case '.wmv':
            case '.mp4':
            case '.ogv':
            case '.qt':
            case '.mov':
            case '.mkv':
              $icone = 'avi';
              break;
            case '.mp3':
            case '.ogg':
            case '.oga':
            case '.wma':
            case '.wav':
            case '.ra':
            case '.rm':
              $icone = 'mp3';
              break;
            case '.txt':
            case '.rtf':
              $icone = 'txt';
              break;
            case '.zip':
            case '.rar':
            case '.7z':
              $icone = 'zip';
              break;
            case '.exe':
            case '.sh':
            case '':
              $icone = 'exe';
              break;
            default :
              $icone = 'defaut';
          }
          if ( $admin )  {
            $id = $r['id'];
            if ( $r['protection'] == 1 )
              $icone .= '-lock';
            $cache = ( $r['protection'] == 2 ) ? ' (non diffusé)' : '';
            $select_reps = str_replace(array("\"$rid\"",'        '),array("\"$rid\" selected","$indent      "),$GLOBALS['select_reps']);
            $select_protection = str_replace("\"${r['protection']}\"","\"${r['protection']}\" selected",'<option value="0">Visible de tous</option><option value="1">Visible après identification</option><option value="2">Non visible</option>');
            echo <<<FIN

$indent<div class="fic admin">
$indent  <span><img class="icone" src="icones/$icone.png">${r['nom']}</span>$cache
$indent  <form action="?rep=${GLOBALS['rid']}${GLOBALS['urladmin']}" method="post" enctype="multipart/form-data">
$indent    <input class="bouton" type="submit" name="envoie" value="Envoyer">
$indent    <p class="ligne"><label for="fichier$id">Mettre à jour&nbsp;: </label><input type="file" id="fichier$id" name="fichier"></p>
$indent    <input type="hidden" name="id" value="$id">
$indent  </form>
$indent  <hr>
$indent  <form action="?rep=${GLOBALS['rid']}${GLOBALS['urladmin']}" method="post">
$indent    <p class="boutons"><input type="submit" name="modifie_doc" value="Valider" title="Valider les modifications"><input type="submit" name="supprime_doc" value="Supprimer" title="Supprimer ce document"></p>
$indent    <p class="ligne"><label for="nomdoc$id">Nom à afficher&nbsp;: </label><input type="text" id="nom$id" name="nom" value="${r['nom']}" size="50"></p>
$indent    <p class="ligne"><label for="parent$id">Répertoire&nbsp;: </label><select id="parent$id" name="parent">
$select_reps$indent    </select></p>
$indent    <p class="ligne"><label for="protecdoc$id">Accès&nbsp;: </label>
$indent      <select id="protecdoc$id" name="protection">$select_protection</select>
$indent    </p>
$indent    <input type="hidden" name="id" value="$id">
$indent    <p class="ligne"><label>Lien&nbsp;: </label><code>&lt;a href="download?id=$id"&gt;${r['nom']}&lt;/a&gt;</code></p>
$indent    <p class="ligne"><a href="download?id=$id">Télécharger</a>|&nbsp;Taille&nbsp;: ${r['taille']}&nbsp;|&nbsp;Diffusé le ${r['upload']}</p>
$indent  </form>
$indent</div>
FIN;
          }
          else  {
            if ( $r['protection'] && !$lecteur )
              $icone .= '-lock';
            echo "
$indent<p class=\"fic\"><a href=\"download?id=${r['id']}\"><img class=\"icone\" src=\"icones/$icone.png\">${r['nom']}</a> (${r['upload']}, ${r['taille']})</p>";
          }
        }
        $resultat->free();
      }
    }

    affichage($mysqli,$rid,1,$lecteur,$admin);
    
  }
  else
    echo "\n  <h3 class=\"warning\">Ce répertoire est vide.</h3>\n\n";
}
else  {
  // Haut de page, menu et message
  $p = 'docs';
  $t = 'Documents à télécharger';
  include('haut.php');
  echo "\n  <h3 class=\"warning\">Ce répertoire n'existe pas.</h3>\n\n";
}

// Interface d'administration : formulaires de modification
if ( $admin )  {

  // Taille maximale de fichier (pour l'aide)
  $taille = min(ini_get('upload_max_filesize'),ini_get('post_max_size'));
  if ( stristr($taille,'m') )
    $taille = substr($taille,0,-1)*1048576;
  elseif ( stristr($taille,'k') )
    $taille = substr($taille,0,-1)*1024;
  $taille = ( $taille < 1048576 ) ? intval($taille/1024).'&nbsp;ko' : intval($taille/1048576).'&nbsp;Mo';

  // Restrictions pour les modifications sur le répertoire
  $indication = $pas_suppr = $disabled = '';
  if ( $rep['nb'] )  {
    $pas_suppr = ' disabled';
    $indication = "\n    <p>Ce répertoire ne peut pas être supprimé car il n'est pas vide.</p>";
  }
  if ( !$rep['parent'] )  {
    $disabled = $pas_suppr = ' disabled';
    $indication = "\n    <p>Ce répertoire est un répertoire racine, il ne peut être ni supprimé, ni renommé, ni déplacé.</p>";
    $select_reps = '        <option></option>';
  }  

  // Choix par défaut de la protection du nouveau document et du sous-répertoire
  $protection = (int)( $rep['protection'] || $_SESSION['protection'] );
  $select_protection = str_replace("\"$protection\"","\"$protection\" selected",'<option value="0">Visible de tous</option><option value="1">Visible après identification</option>');

  // HTML
?>

  <div class="item aide">
    <h3>Aide et explications</h3>
    <p>Vous pouvez ici modifier le répertoire <?php echo $rep['nom']; ?> ainsi que l'ensemble des documents contenus dans les sous-répertoires. Les répertoires s'ouvrent en cliquant sur leur icone. Les documents sont modifiables en cliquant sur leur nom ou leur icone.</p>
    <p>Les liens vers les répertoires et les documents ne sont jamais modifiés par un déplacement ou un changement de nom.</p>
    <p>Le lien dans le menu vers la page de téléchargement est généré automatiquement, seulement si des documents sont disponibles.</p>
    <h4>Répertoire <?php echo $rep['nom']; ?></h4>
    <p>La case à cocher <em>Demande d'identification pour l'affichage du contenu</em> permet de restreindre la visibilité du répertoire aux visiteurs qui se sont identifiés. Dans ce cas, après <a href="utilisateurs">avoir créé un compte pour les élèves ici</a>, ces informations seront accessibles aux élèves auxquels vous aurez donné l'identifiant et le mot de passe choisis.</p>
    <p>La case à cocher <em>Propager le choix ci-dessus à chaque document/sous-répertoire</em> permet de faire suivre le choix précédent à l'ensemble du contenu du répertoire. Si elle est décochée, aucune modification supplémentaire n'a lieu. Si elle est cochée, une action sera effectuée même si la précédente case n'a pas changé d'état.</p>
    <p>Seuls les répertoires vides peuvent être supprimés. Le répertoire <em>Général</em> et les répertoires à la racine de chaque matière ne peuvent être renommés, déplacés ou supprimés.</p>
    <h4>Nouveau document</h4>
    <p>Vous pouvez envoyer des fichiers grâce au formulaire. Le <em>nom à afficher</em> sera le nom réellement affiché sur le site web (sans extension&nbsp;: elle est détectée automatiquement lors de l'envoi). Si vous laissez cette case vide, le nom du fichier envoyé sera récupéré.</p>
    <p>Vous pouvez choisir la visibilité du document parmi trois possibilités&nbsp;:</p>
    <ul>
      <li><em>Visible de tous</em>&nbsp;: document accessible de tout visiteur</li>
      <li><em>Visible après identification</em>&nbsp; document accessible uniquement après identification, par exemple pour que seuls vos élèves les voient. Il faut alors <a href="utilisateurs">créer un utilisateur de type élève</a>.</li>
      <li><em>Non visible</em>&nbsp;: le document n'est pas encore visible en ligne. Cela peut être utile si vous souhaitez le mettre à disposition ultérieurement. C'est complètement sûr&nbsp;: vous pouvez mettre comme cela le prochain sujet de devoir ou même le corrigé.</li>
    </ul>
    <p>La taille du fichier envoyé est limitée à <?php echo $taille; ?>. Tout document est modifiable et déplaçable, sans que cela ne modifie le lien vers le document.</p>
    <h4>Nouveau sous-répertoire</h4>
    <p>Il est possible de créer autant de sous-répertoire que vous le souhaitez. La case à cocher <em>Demande d'identification pour l'affichage du contenu</em> permet de restreindre la visibilité du répertoire aux visiteurs qui se sont identifiés. Dans ce cas, après <a href="utilisateurs">avoir créé un compte pour les élèves ici</a>, ces informations seront accessibles aux élèves auxquels vous aurez donné l'identifiant et le mot de passe choisis.</p>
    <h4>Modification des documents déjà envoyés</h4>
    <p>Les documents sont modifiables en cliquant sur leur nom ou leur icone.</p>
    <p>Vous pouvez <em>mettre à jour</em> un document déjà envoyé&nbsp;: cela évite de supprimer/recréer le document, et permet aux liens vers le document d'être toujours valables (l'adresse ne change pas).</p>
    <p>Vous pouvez aussi renommer et déplacer tout document. Le lien correspondant ne changera pas.</p>
    <p>Vous pouvez choisir la visibilité du document parmi trois possibilités&nbsp;:</p>
    <ul>
      <li><em>Visible de tous</em>&nbsp;: document accessible de tout visiteur</li>
      <li><em>Visible après identification</em>&nbsp; document accessible uniquement après identification, par exemple pour que seuls vos élèves les voient. Il faut alors <a href="utilisateurs">créer un utilisateur de type élève</a>.</li>
      <li><em>Non visible</em>&nbsp;: le document n'est pas encore visible en ligne. Cela peut être utile si vous souhaitez le mettre à disposition ultérieurement. C'est complètement sûr&nbsp;: vous pouvez mettre comme cela le prochain sujet de devoir ou même le corrigé.</li>
    </ul>
  </div>

  <div class="item admin">
  <form action="<?php echo "?rep=$rid$urladmin"; ?>" method="post">
    <input class="bouton" type="submit" name="modifie" value="Valider" title="Valider les modifications">
    <input class="bouton" type="submit" name="supprime" value="Supprimer" title="Supprimer ce répertoire"<?php echo $pas_suppr;?>>
    <h3>Modifier le répertoire <em><?php echo $rep['nom']; ?></em></h3>
    <p class="ligne"><label for="nomrep">Nom&nbsp;: </label><input type="text" id="nomrep" name="nom" value="<?php echo $rep['nom']; ?>" size="50"<?php echo $disabled;?>></p>
    <p class="ligne"><label for="parent">Répertoire parent&nbsp;: </label>
      <select id="parent" name="parent"<?php echo $disabled;?>>
<?php echo str_replace("\"${rep['parent']}\"","\"${rep['parent']}\" selected",$select_reps); ?>
      </select>
    </p>
    <p class="ligne"><label for="protecrep">Demande d'identification pour l'affichage du contenu&nbsp;: </label><input type="checkbox" id="protecrep" name="protection" value="1"<?php echo ( $rep['protection'] ) ? ' checked' : ''; ?>></p>
    <p class="ligne"><label for="propagation">Propager le choix ci-dessus à chaque document/sous-répertoire&nbsp;: </label><input type="checkbox" id="propagation" name="propagation" value="1"></p><?php echo $indication;?>
  </form>
  </div>

  <div class="item admin">
  <form action="<?php echo "?rep=$rid$urladmin"; ?>" method="post" enctype="multipart/form-data">
    <input class="bouton" type="submit" name="envoie" value="Envoyer">
    <h3>Déposer un document dans le répertoire <em><?php echo $rep['nom']; ?></em></h3>
    <p class="ligne"><label for="nomdoc">Nom à afficher&nbsp;: </label><input type="text" id="nomdoc" name="nom" value="" size="50"></p>
    <p class="ligne"><label for="fichier">Fichier&nbsp;: </label><input type="file" id="fichier" name="fichier"></p>
    <p class="ligne"><label for="protecdoc">Accès&nbsp;: </label>
      <select id="protecdoc" name="protection"><?php echo $select_protection; ?><option value="2">Non visible</option></select>
    </p>
    <input type="hidden" name="id" value="0">
  </form>
  </div>

  <div class="item admin">
  <form action="<?php echo "?rep=$rid$urladmin"; ?>" method="post" enctype="multipart/form-data">
    <input class="bouton" type="submit" name="cree" value="Créer">
    <h3>Créer un sous-répertoire</h3>
    <p class="ligne"><label for="nomssrep">Nom&nbsp;: </label><input type="text" id="nomssrep" name="nom" value="" size="50"></p>
    <p class="ligne"><label for="protecssrep">Demande d'identification pour l'affichage du contenu&nbsp;: </label><input type="checkbox" id="protecssrep" name="protection" value="1"<?php echo ( $protection ) ? ' checked' : ''; ?>></p>
  </form>
  </div>

  <script type="text/javascript">
$( function() {
  $('.fic span').replaceWith(function() { return '<a href="">'+$(this).html()+'</a>'; });
  $('.fic > a').click( function () {
    $(this).parent().find('form,hr').toggle();
    $(this).parent().toggleClass('admin');
    return false;
  }).click();
});
  </script>
<?php
}

$lock = ( $admin ) ? '' : ':not(.lock)';
?>

  <script type="text/javascript">
$( function() {
  $('p.rep<?php echo $lock; ?> img').css('cursor','pointer').click( function () {
    var p = $(this).parent();
    p.toggleClass('open');
    p.parent().children('.fic,div.rep').toggle();
    $(this).attr('src',function(i,val){ return val.replace(p.is('.open')?'rep':'rep-open',p.is('.open')?'rep-open':'rep'); });
  });
  $('p.rep<?php echo $lock; ?> img').attr('src',function(i,val){return val.replace('rep-open','rep');}).parent().removeClass('open');
  $('div.rep .fic,div.rep div.rep').hide();
//  $('#parents').after('<p>Vous pouvez ouvrir ou fermer des répertoires en cliquant sur leur icone.</p>');
});
  </script>
  
<?php
$mysqli->close();

// Bas de page
include('bas.php');


exit();
?>


  <script type="text/javascript">
$( function() {
<?php
  if ( $admin )  {
?>
  $('.fic span').replaceWith(function() { return '<a href="">'+$(this).html()+'</a>'; });
  $('.fic a').click( function () {
    $(this).parent().find('form,hr').toggle();
    $(this).parent().toggleClass('admin');
    return false;
  }).click();
});
<?php
  }
?>
  $('p.rep<?php echo $lock; ?> img').css('cursor','pointer').click( function () {
    var p = $(this).parent();
    p.toggleClass('open');
    p.parent().children('.fic:not(form,hr),div.rep').toggle();
    $(this).attr('src',function(i,val){ return val.replace(p.is('.open')?'rep':'rep-open',p.is('.open')?'rep-open':'rep'); });
    
  });
  $('p.rep<?php echo $lock; ?> img').attr('src',function(i,val){return val.replace('rep-open','rep');}).parent().removeClass('open');
  //$('div.rep .fic:not(form,hr),div.rep div.rep').hide();
  $('#parents').after('<p>Vous pouvez ouvrir ou fermer des répertoires en cliquant sur leur icone.</p>');
});
  </script>

<?php
